"""
Django settings for finanztool project.

Generated by 'django-admin startproject' using Django 2.1.3.

For more information on this file, see
https://docs.djangoproject.com/en/2.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.1/ref/settings/
"""

import fnmatch
import os
import sys

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.1/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.environ.get("SECRET_KEY", default="t)(c6pa&ad=sz6&0sgv&5g(z=9)n6@q8u@a)m3zzy)&78u@n5)")

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = os.environ.get("DEBUG", default="1") == "1"
DEBUG_BRANDING = os.environ.get("DEBUG_BRANDING", default="DEVELOPEMENT (non-docker)")

ALLOWED_HOSTS = ["localhost", "backend"]
CSRF_TRUSTED_ORIGINS = []
if "URL" in os.environ:
    CSRF_TRUSTED_ORIGINS.append(os.environ["URL"])

# Application definition

INSTALLED_APPS = [
    "finanztool.pdf.apps.PdfConfig",
    "finanztool.core.apps.FinanztoolConfig",
    "finanztool.api.apps.ApiConfig",
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
    "mozilla_django_oidc",
    "adminsortable2",
    "drf_spectacular",
    "drf_spectacular_sidecar",
    "rest_framework",
]

MIDDLEWARE = [
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
    "finanztool.middleware.fix_build_absolute_uri",
    "finanztool.middleware.KeycloakSessionRefresh",
]

ROOT_URLCONF = "finanztool.config.urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [os.path.join(BASE_DIR, "finanztool/core/frontend")],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
                "finanztool.core.context_processors.debug_branding",
            ],
        },
    },
]

WSGI_APPLICATION = "finanztool.config.wsgi.application"


# Database
# https://docs.djangoproject.com/en/2.1/ref/settings/#databases

DATABASES = {
    "default": {
        "ENGINE": "django.db.backends.postgresql_psycopg2",
        "NAME": "test_postgres" if fnmatch.filter(sys.argv, "*test*") else "postgres",
        "USER": "postgres",
        "PASSWORD": "postgres",
        "HOST": "postgres",
        "PORT": "5432",
        "TEST": {
            "NAME": "test_postgres",
        },
    },
    "test": {
        "ENGINE": "django.db.backends.postgresql_psycopg2",
        "NAME": "test_postgres",
        "USER": "postgres",
        "PASSWORD": "postgres",
        "HOST": "postgres",
        "PORT": "5432",
    },
}


# Password validation
# https://docs.djangoproject.com/en/2.1/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",
    },
]

AUTHENTICATION_BACKENDS = (
    "finanztool.auth.KeycloakAuth",
    "django.contrib.auth.backends.ModelBackend",
)

# Internationalization
# https://docs.djangoproject.com/en/2.1/topics/i18n/

LANGUAGE_CODE = "de"

TIME_ZONE = "UTC"

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.1/howto/static-files/

STATIC_ROOT = "static/"
STATIC_URL = "/static/"
MEDIA_ROOT = "data/media"
MEDIA_URL = "/media/"

LOGIN_REDIRECT_URL = "/"
LOGOUT_REDIRECT_URL = "/"

# File upload
FILE_UPLOAD_HANDLERS = [
    "finanztool.uploadhandler.QuotaUploadHandler",
    "django.core.files.uploadhandler.MemoryFileUploadHandler",
    "django.core.files.uploadhandler.TemporaryFileUploadHandler",
]

# Required for admin actions affecting many datasets
DATA_UPLOAD_MAX_NUMBER_FIELDS = 1000000

# Email
EMAIL_BACKEND = os.environ.get("EMAIL_BACKEND", default="django.core.mail.backends.console.EmailBackend")
EMAIL_HOST = os.environ.get("EMAIL_HOST", default="mail.fs.tum.de")
EMAIL_PORT = os.environ.get("EMAIL_PORT", default="587")
EMAIL_USE_TLS = os.environ.get("EMAIL_USE_TLS", default="True")
EMAIL_HOST_USER = os.environ.get("EMAIL_HOST_USER", default="astafinanztoolservice")
EMAIL_HOST_PASSWORD = os.environ.get("EMAIL_HOST_PASSWORD")
DEFAULT_FROM_EMAIL = "noreply-finanztool@fs.tum.de"

# standard 32 bit integer primary keys like django before 3.2
DEFAULT_AUTO_FIELD = "django.db.models.AutoField"

REST_FRAMEWORK = {
    "DEFAULT_SCHEMA_CLASS": "drf_spectacular.openapi.AutoSchema",
    "DEFAULT_AUTHENTICATION_CLASSES": [
        "rest_framework.authentication.SessionAuthentication",
    ],
    "DEFAULT_PERMISSION_CLASSES": [
        "rest_framework.permissions.IsAuthenticated",
    ],
    "DEFAULT_RENDERER_CLASSES": [  # disable fancy HTML browseable API
        "rest_framework.renderers.JSONRenderer",
    ],
    "TEST_REQUEST_DEFAULT_FORMAT": "json",
}

SPECTACULAR_SETTINGS = {
    "TITLE": "Finanz-Tool API",
    "DESCRIPTION": "Finanz-Tool - Studentische Vertretung TUM",
    "VERSION": "1.0.0",
    "SWAGGER_UI_DIST": "SIDECAR",
    "SWAGGER_UI_FAVICON_HREF": "SIDECAR",
    "SERVE_PERMISSIONS": ["finanztool.api.permissions.IsSuperUser"],
    "COMPONENT_SPLIT_REQUEST": True,
}

CACHES = {
    "default": {
        "BACKEND": "django.core.cache.backends.filebased.FileBasedCache",
        "LOCATION": "/tmp/django-cache",
        "TIMEOUT": None,
        "OPTIONS": {"MAX_ENTRIES": 5000},
    },
}


# SSO Config for keycloak
OIDC_RP_CLIENT_ID = os.environ.get("OIDC_RP_CLIENT_ID", "")
OIDC_RP_CLIENT_SECRET = os.environ.get("OIDC_RP_CLIENT_SECRET", "")
OIDC_OP_AUTHORIZATION_ENDPOINT = os.environ.get("OIDC_OP_AUTHORIZATION_ENDPOINT", "")
OIDC_OP_TOKEN_ENDPOINT = os.environ.get("OIDC_OP_TOKEN_ENDPOINT", "")
OIDC_OP_USER_ENDPOINT = os.environ.get("OIDC_OP_USER_ENDPOINT", "")
LOGIN_REDIRECT_URL_FAILURE = "/new/unauthorized"
OIDC_OP_LOGOUT_URL = os.environ.get("OIDC_OP_LOGOUT_URL", "")
ALLOW_LOGOUT_GET_METHOD = True
OIDC_CREATE_USER = False
OIDC_OP_LOGOUT_URL_METHOD = "finanztool.auth.provider_logout"
OIDC_RP_SIGN_ALGO = os.environ.get("OIDC_RP_SIGN_ALGO", "RS256")
OIDC_OP_JWKS_ENDPOINT = os.environ.get("OIDC_OP_JWKS_ENDPOINT", "")
